<?php
/*
 *  TT-SQL, - The SQL part of TT-CHESS
 *  More information is available at http://www.chesstech.net/ttchess
 *  Copyright (C) 2003 Jonas Forsslund (jofo02@kth.se)
 *  All rights reserved.
 *
 *  TT-SQL is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  TT-SQL is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with ICTK; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

include("config.inc");

/* Connect to SQL server */
mysql_connect($host, $login, $password);


/*
 * Teams class
 * Loads the Team list
 *
 */
 class Teams extends Config{
   var $names;

  function Teams(){
    $query="select id,name from teams";
    $result = mysql_db_query($this->database,$query);
    while ($row = mysql_fetch_array($result)) {
      $id = $row["id"];
      $this->names[$id] = $row["name"];
    }
  }

  function getTeamName($id){
    return $this->names[$id];
  }


 }


/*
 * Game class
 * Loads a game (a board with extra information) from database
 *
 */
class Game extends Config{
  var $id;
  var $date;
  var $site;
  var $table;
  var $dgt_board;
  var $dgt_active;
  var $dgt_active_fen;
  var $dgt_active_moves;
  var $dgt_active_getmoves;
  var $dgt_active_connected;
  var $white; // a Player type
  var $black; // a Player type
  var $wtime;
  var $btime;
  var $fen;
  var $turn;
  var $moves;
  var $result;
  var $updated;
  var $owner;
  var $round;
  var $comments;
  var $tournament;

  function loadId($id){
    $query="select *, dgt_active like '%Fen%' as aFen, dgt_active like '%Moves%' as aMoves, dgt_active like '%GetMoves%' as aGetMoves, dgt_active like '%Connected%' as aConnected from games where id=$id";
    $result = mysql_db_query($this->database,$query);
    while ($row = mysql_fetch_array($result)) {
      $this->dgt_active_fen = $row["aFen"];
      $this->dgt_active_moves = $row["aMoves"];
      $this->dgt_active_getmoves = $row["aGetMoves"];
      $this->dgt_active_connected = $row["aConnected"];

      $this->id = $id;
      $this->tournament = $row["tournament"];
      $this->date = $row["date"];
      $this->site = $row["site"];
      $this->table = $row["table"];
      $this->dgt_board = $row["dgt_board"];
      $this->dgt_active = $row["dgt_active"];
      $this->wtime = $row["wtime"];
      $this->btime = $row["btime"];
      $this->fen = $row["fen"];
      $this->turn = $row["turn"];
      $this->moves = $row["moves"];
      $this->result = $row["result"];
      $this->updated = $row["updated"];
      $this->owner = $row["owner"];
      $this->round = $row["round"];
      $this->comments = $row["comments"];

      $this->white = new Player($row["white"]+0);
      $this->black = new Player($row["black"]+0);
    }
  }

  function Game($id=0){
    if($id>0)
      $this->loadId($id);
    else {
      $this->id = 0;
      $this->fen = "8/8/8/8/8/8/8/8";
      $this->active = "";
      $this->updated = "";
      $this->comments = "";
      $this->white = new Player();
      $this->black = new Player();
    }
  }

  function printBoard($pieces="small") { printBoard($this->fen,0,$pieces); }
  function printBoardSize($pieces, $size) { printBoard($this->fen,0,$pieces,$size); }

  function online() {
    if(strpos($this->dgt_active,"Fen")) return true;
    else return false;
  }

}



/*
 * Player class
 * Loads a player from the database given its ID
 *
 */
class Player extends Config{
  var $id;
  var $elo;
  var $team;
  var $firstname;
  var $lastname;
  var $rating;
  var $presentation;
  var $titel;
  var $photo;
  var $link;
  var $country;


  function Player($requestid=0) {
      if($requestid>0)
        $this->loadId($requestid);
      else {
        $this->id = -1;
        $this->titel = "";
        $this->firstname = "";
        $this->lastname = "Unset";
        $this->elo = 0;
        $this->presentation = "";
        $this->rating = 0;
        $this->photo = "";
        $this->link = "";
        $this->country = "SWE";
      }
  }

  function loadId($requestid) {
    $result = mysql_db_query($this->database,"select team, country, id, rating, photo, titel, firstname, lastname, elo, presentation from players where id = $requestid");
    while ($row2 = mysql_fetch_array($result)) {
      $this->id = $row2["id"];
      $this->team = $row2["team"];
      $this->titel = $row2["titel"];
      $this->country = $row2["country"];
      $this->firstname = $row2["firstname"];
      $this->lastname = $row2["lastname"];
      $this->elo = $row2["elo"];
      $this->presentation = $row2["presentation"];
      $this->rating = $row2["rating"];
      $this->photo = $row2["photo"];
      $this->link = "(<A HREF=\"playerinfo.php?playerid=$this->id\">?</A>)";
    }

  }

  /* Add current player to database */
  function save() {
      $query="insert into players set titel='$this->titel', firstname='$this->firstname', lastname='$this->lastname',      elo='$this->elo', rating='$this->rating',team='$this->team', photo='$this->photo', presentation='$this->presentation'";

      mysql_db_query($this->database,$query);
  }

  function update() {
      mysql_db_query($this->database,"update players set titel='$this->titel', firstname='$this->firstname', lastname='$this->lastname',
      elo='$this->elo', rating='$this->rating', presentation='$this->presentation' where id = $this->id");
  }

}


/*
 * printPieces($theme)
 * Prints out the complete piece-set, so the browser can cache them
 *
 */
function printPieces($theme, $rows=1){
 $a = "<img src=\"pieces/" . $theme . "/";
 $b = ".png\">";
if($rows == "-1") $b = ".png\" width=\"1\" height=\"1\">";
if($rows == "-2") $b = ".png\" width=\"0\" height=\"0\">";

 echo $a . "w" . $b;
 echo $a . "wP" . $b;
 echo $a . "wB" . $b;
 echo $a . "wN" . $b;
 echo $a . "wR" . $b;
 echo $a . "wQ" . $b;
 echo $a . "wK" . $b;

if($rows==4) echo "<BR>";

 echo $a . "wp" . $b;
 echo $a . "wb" . $b;
 echo $a . "wn" . $b;
 echo $a . "wr" . $b;
 echo $a . "wq" . $b;
 echo $a . "wk" . $b;

if($rows==2) echo "<BR>";

 echo $a . "bp" . $b;
 echo $a . "bb" . $b;
 echo $a . "bn" . $b;
 echo $a . "br" . $b;
 echo $a . "bq" . $b;
 echo $a . "bk" . $b;

if($rows==4) echo "<BR>";

 echo $a . "bP" . $b;
 echo $a . "bB" . $b;
 echo $a . "bN" . $b;
 echo $a . "bR" . $b;
 echo $a . "bQ" . $b;
 echo $a . "bK" . $b;
 echo $a . "b" . $b;




}

/*
 * printBoard($fen)
 * Prints a diagram given
 *   FEN
 *   Rotated (1) or not (0)
 *   Theme ("small", "wedberg" or other set in pieces directory)
 *   Size (optional) "size='5'" or similar img-attribute)
 *
 */
function printBoard($fen, $rotate, $theme, $size=""){
  if($rotate){
    $fen+=" ";
    $fen= strrev(  substr($fen,0,strpos($fen," ")));
  }

  $layout="<img border=\"0\" src=\"pieces/" . $theme . "/";

  $length = strlen($fen);
  $row=0; $char=0; $c=1;
  while($c<64+7+1){

    $output = $layout;
    if($fen{$char} >= '1' && $fen{$char} <= '8'){
        for($i=0;$i<$fen{$char};$i++){
          if($c%2) echo $layout . "w.png\" ALT=\". \" $size>";
              else echo $layout . "b.png\" ALT=\". \" $size>";
          $c++;
        }
        $c--;
	$output="";
    }
    else if($fen{$char}=='/')
        $output = "<BR>\n";
    else {
      if($c%2) $output .= "w" . $fen{$char} . ".png\" $size ALT=\"". $fen{$char} . " \">";
      else $output .= "b" . $fen{$char} . ".png\" $size ALT=\"". $fen{$char} . " \">";
    }

    echo $output;


    $c++;
    $char++;
  }
}



?>

