
import java.util.*;

// The database that contains all chessboards. The goal of the application is
// to keep this database as close to reality as possible.
class ttchess_database {

	Hashtable boards;

	public ttchess_database() {
		boards = new Hashtable();
	}

	// Return specified board. If no such board exists in the database, then create one.
	ttchess_chessboard get_board(int address) {
		Integer _address = new Integer(address);
		ttchess_chessboard b = (ttchess_chessboard)(boards.get(_address));
		if (b==null) {  // Create new board
			System.out.println("New board found: ID="+_address.toString());
			b = new ttchess_chessboard(_address, this);
			boards.put(_address, b);
		}
		return b;
	}

	int get_boardcount() {
		return boards.size();
	}

	Enumeration get_boards() {
		return boards.elements();
	}

	void unalive_all() { // set alive to false on all boards
		for (Enumeration e = boards.elements() ; e.hasMoreElements() ;) {
			((ttchess_chessboard)(e.nextElement())).set_alive(false);
		}
	}

	int count_alive() { // count number of alive boards
		int x = 0;
		for (Enumeration e = boards.elements() ; e.hasMoreElements() ;) {
			if (((ttchess_chessboard)(e.nextElement())).get_alive()==true) x=x+1;
		}
		return x;
	}

}
